<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: matcher.php,v 1.4 2003/07/09 19:32:48 glandium Exp $

/**
* This is the Base-Class for all matchers
*
* Matchers are used in <map:match> in sitemap.xml
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: matcher.php,v 1.4 2003/07/09 19:32:48 glandium Exp $
* @package  papaan
* @module	matchers
*/
class matcher {
	var $debug = False;

	function matcher(&$sitemap, $config) {
		$this->sitemap = &$sitemap;
		$this->config = $config;
	}

	function init($attribs)
    {
	    $this->attribs = $attribs;
        $debug = $this->getAttrib('debug');
        if (!is_null($debug) && $debug!='no'  )
        {
        	$this->debug = True;
            $GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = '---';
            $GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = 'matcher:'.get_class($this);

            foreach ($this->attribs as $key => $value)
            {
            	$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = "$key => $value";
            }
			$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = '---';
		}
    }
    
	function match() {
	}

    function setMatcherHits($array) {

		$this->sitemap->addMap($array);

	}

    function getAttrib($attribute) {
	    if (isset($this->attribs[$attribute]))
        {
			return $this->attribs[$attribute];
		}
        else
        {
        	return Null;
		}
	}

    /**
    * Adds an entry to the debug Output
    *  if $this->debug is true
    *
    * @param  mixed  content  text to be added
    * @access private
    */
    function printDebug($content)
    {
		if ($this->debug)
        {
			$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = $content;
    	}
    }

    /**
    * Adds an decomposed Array to the debug Output
    *  if $this->debug is true
    *
    * @param  array array Array to be added
    * @param  string description line to be added before array
    * @access private
    */    
    function printDebugArray($array,$description = '')
    {
		if ($this->debug)
        {
			$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = $description;
        	foreach($array as $key => $value)
            {
				$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = "$key => $value";
			}
    	}
    }
}

class matcher_wildcard extends matcher {

function matcher_wildcard(&$sitemap, $config) {
	parent::matcher($sitemap, $config);
}
function match($pattern, $value) {
	$pattern_new = str_replace('\*','([^\/]*)',
		str_replace('\*\*','(.*)',
		preg_quote($pattern,'/')));
	if ($pattern_new == $pattern) {
		if ($value == $pattern) {
			$matches = array($value, $value);
		} else {
			$matches = array();
		}
	} else {
		preg_match('/^'.$pattern_new.'$/',$value, $matches);
	}
	$this->setMatcherHits($matches);
	if (isset($matches[0])) {
		return True;
	} else {
		return False;
	}

}

}

class matcher_regexp extends matcher {

function matcher_regexp(&$sitemap, $config) {
	parent::matcher($sitemap, $config);
}

function match($pattern, $value) {
	preg_match($value,$this->sitemap->uri, $matches);
	$this->setMatcherHits($matches);
	if (isset($matches[0])) {
		return True;
	} else {
		return False;
	}
}
    
}
