<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: resource.php,v 1.6 2003/07/20 11:03:51 glandium Exp $

include_once(PAPAAN_BASE.'/components/reader.php');

/**
 * @author   Christian Stocker <chregu@bitflux.ch>
 * @version  $Id: resource.php,v 1.6 2003/07/20 11:03:51 glandium Exp $
 * @package  papaan
 */
class reader_resource extends reader {

    var $attribs = array();
    
	/**
     * Constructor, does nothing at the moment
     */
	function reader_resource (&$sitemap, $config) {
        $this->reader($sitemap, $config);
	}

	/**
     * Initiator, called after construction of object
     *
     *  This method will be called in the start element with the attributes from this element
     *
     *  As we just call the parent init method, it's not really needed, 
     *  it's just here for reference
     *
     *  @param $attribs array	associative array with element attributes
     *  @access public
     */
    function init($attribs)
    {
    	parent::init($attribs);
    }   
	
    /**
     * Prints file content 
     *
     * @access public
     */
    function start()
    {
        $mimetype = $this->getAttrib('mime-type');
//        $src = str_replace('..','',$this->getAttrib('src'));  
        $src = $this->getAttrib('src');  
        if ($mimetype == 'auto') {
                    $mimetype= $this->getMimeType($src);
        }
        
        if ($mimetype) {
            $this->sitemap->setContentType($mimetype);
        }

        if (!($content = $this->readfile($src,false))) {
            papaan::raiseError($this->getAttrib('src') . ' could not be loaded', PAPAAN_ERROR_WARNING);
        } 
	return $content;
    }
    function getMimeType($src) {
        $extension = substr($src,strrpos($src,'.')+1);
        
        switch ($extension) {
            case 'gif':
                return 'image/gif';
            case 'jpg':
            case 'jpeg':
                return 'image/jpeg';
            case 'png':
                return 'image/png';
            case 'css':
                return 'text/css';
            case 'xml':
            case 'xsl':
            case 'xsd':
                return 'text/xml';
            case 'js':
                return 'text/javascript';
            case 'html':
            case 'htm':
                return 'text/html';
            case 'txt':
                return 'text/plain';
            
            default:
                if (file_exists($src)) {
                    $m =  `file -b $src`;
                    return $m;
                } else {
                    return 'text/plain';
                }
        }
        
        
    }
}


?>
