<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: component.php,v 1.14 2003/07/22 17:59:50 glandium Exp $

/**
* Documentation is missing at the moment...
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: component.php,v 1.14 2003/07/22 17:59:50 glandium Exp $
* @package  papaan
*/

class component {

	var $debug = False;
    
    var $hasSaxInput = False;
    var $hasSaxOutput = False;    
    var $hasDomInput = False;    
    var $hasDomOutput = False;        
    var $hasXmlStringInput = False;        
    var $hasXmlStringOutput = False;            
	var $params = array();    
	/**
    * Constructor, does nothing at the moment
	*/
	function component(&$sitemap, $config)
    {
		$this->sitemap = &$sitemap;
		$this->config = $config;
    }

	/**
    * Initiator, called after construction of object
    *
    *  This method will be called in the start element with the attributes from this element
    *
    *  @param $attribs array	associative array with element attributes
    *  @access public
	*/
	function init($attribs)
    {
    	$this->attribs = $attribs;

		/*override class default vars from above with attribute from sitemap.xml */        
		foreach($this->attribs as $key => $value)
        {
            if (isset ($this->$key))
            {
				$_attr = $this->getAttrib($key);
				if ($_attr !== null) {
					$this->$key = $_attr;
				}
			}
		}

        //if we should debug
        $debug = $this->getAttrib('debug');
        if (!is_null($debug) && $debug!='no'  )
        {
        	$this->debug = True;
            $GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = '---';
            $p = get_parent_class($this);
            while ($pnew = get_parent_class($p))
            {
            	if ($pnew == 'component') { break;}
                $p = $pnew;
			}          
            $GLOBALS['_PAPAAN_globalContainer']->debugOutput[] =$p.': '.get_class($this);

            foreach ($this->attribs as $key => $value)
            {
            	$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = "$key => $value";
            }
			$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = '---';
		}
    }

    function getAttrib($attribute) {
	    if (isset($this->attribs[$attribute]))
        {
				if (! isset($this->sitemap)) {
					die('The class '.get_class($this). ' has no sitemap integrated');
				}
			

				return $this->attribs[$attribute];
		}
        else
        {
        	return Null;
		}
	}
    
	function setParameter($key,$value) 
	{
		if (!isset($this->params))
		{
			$this->params = array();
		}
		$this->params[$key]=$value;
	}
		
	function getParameter($key = false) {

		if ($key) 
		{
			if (isset($this->params[$key])) 
			{
				return $this->params[$key];
			}
			else
			{
				return null;
			}
		}
		else
		{		
			if (isset($this->params)) {
				$retarr = array();
				foreach ($this->params as $value => $key) 
				{
					$retarr[$value] = $key;
				}
				return $retarr;
			} 
			else 
			{
				return array();
			}
		}
	}
	

    /**
    * Adds an entry to the debug Output
    *  if $this->debug is true
    *
    * @param  mixed  content  text to be added
    * @access private
    */

    function printDebug($content)
    {
		if ($this->debug)
        {
			$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = $content;
    	}
    }
    /**
    * Adds an decomposed Array to the debug Output
    *  if $this->debug is true
    *
    * @param  array array Array to be added
    * @param  string description line to be added before array
    * @access private
    */    
    function printDebugArray($array,$description = '')
    {
		if ($this->debug)
        {
			$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = $description;
            if (is_array($array))
            {
        	foreach($array as $key => $value)
            {
				$GLOBALS['_PAPAAN_globalContainer']->debugOutput[] = "$key => $value";
			}
            }
    	}
    }
    
    /* Readfile stuff */
    function readfile($source, $want_dom = true)
    {
    /* TODO : add a better protocol handling to handle the jar: thing ; add real caching stuff (use global cache) */
    	$src = $source;
	$buffer = '';
	if (substr($src,0,8) == 'papaan:/') {
		$options = array('internal'=>true);
		if ($want_dom) {
			$options['serialize'] = false;
		}
		$uri = substr($src,8);
		if ($uri[0] == '/') {
			$sitemap = new sitemap($this->sitemap->root->file, $uri,$options,$this->sitemap);
		} else {
			$sitemap = new sitemap($this->sitemap->file, $uri,$options,$this->sitemap);
		}
		if ($sitemap->runSitemap()) {
			$buffer = $sitemap->xml;
		}
	} else if (substr($src,0,10) == 'context://') {
		$src = substr($src, 10);
	} else if (preg_match('#^([a-z]+)://(([^/]+)(/.*))?#',$src,$matches)) {
		if ($matches[1] == 'http') {
			$src = './tmp/'.str_replace(array(DIRECTORY_SEPARATOR,':'),'_',$src);
			if (file_exists($src)) {
				$date = filemtime($src);
				$fulldate = gmdate('D, d M Y H:i:s T',$date);
			}
			$fh = fsockopen($matches[3], 80);
			if ($fh) {
				fputs($fh, 'GET '.$matches[4].' HTTP/1.0'."\r\n".'Host: '.$matches[3]."\r\n".'User-Agent: Papaan v'.PAPAAN_VERSION."\r\n".'Connection: close'."\r\n");
				if (isset($date)) {
					fputs($fh, 'If-Modified-Since: '.$fulldate."\r\n");
				}
				fputs($fh, "\r\n");
				list(,$code) = split(' ',fgets($fh),3);
				while (rtrim(fgets($fh))) {}
				if ($code != 304) {
					while(!feof($fh)) { $buffer .= fread( $fh, 1048576 ); }
					if ($fd = fopen($src, 'w')) {
						fwrite($fd,$buffer);
						fclose($fd);
					}
				}
				fclose($fh);
			}
		} else {
			$this->raiseError('unsupported-protocol','Unsupported protocol: '.$matches[1]);
		}
	} else {
		if ($src[0] != '/') {
			$src = $this->sitemap->base_dir.'/'.$src;
		}
	}
	if ($buffer === '') {
		if (is_file($src)) {
			if ($fd = fopen($src,'rb')) {
				while(!feof($fd)) { $buffer .= fread($fd, 1048576); }
				fclose($fd);
			}
		}
	}
	if ($buffer === '') {
		$this->raiseError('resource-not-found',$source.': can\'t open file or file empty');
	}
	if (is_string($buffer) && $want_dom) {
		$this->sitemap->var2XMLObject($buffer);
	}
    	return $buffer;
    }

    function raiseError($type, $msg, $description = null) {
    	$this->sitemap->raiseError(&$this, $type, $msg, $description);
    }

    /* CACHING STUFF */
    /*
       Hannes' comment:
       Here come the default methods. generateKeyDefault() is sort of generic, while
       the other two methods are valid but for components interacting with filesystem.
       It seemed to me that in putting them here I came away with the least amount of
       duplicate code.
       Correct me if this was a bad choice.
    */      
    
    /**
     * Generate unique key from an array and a string (seen abstractly)
     *
     * @param  array  $attribs Array of component attributes
     * @param  string hash key of previous component in pipeline
     * @return string md5 hash key of the mashed parameters
     * @author Hannes Gassert <hannes.gassert@unifr.ch>
     * @see componentCache
     */
    function generateKeyDefault($attribs, $keybefore){
        $attribs[] = $keybefore;
        return(md5(serialize($attribs)));
    }

    /**
     * Generate validityObject
     *
     * This is common to all file-reading components. As they're probably largest in number,
     * they are allowed to be the default methods.
     *
     * @see  checkvalidity
     * @return  array  $validityObject contains the components attributes plus file modification time and time of last access.
     */
    function generateValidityDefault(){
        $validityObject = $this->attribs;
        if(isset($validityObject['src'])){
            $validityObject['filemtime'] = filemtime($this->attribs['src']);
            $validityObject['fileatime'] = fileatime($this->attribs['src']);
        }
        return($validityObject);
    }

    /**
     * Check validity of a validityObject from cache: NOT REALLY DONE YET!!
     *
     * It's the same thing as with all validity checkers: there are many more ways to determine
     * cache validity. things like "access + 4 days" (which would also involve sending appropriate http headers)
     * are not implemented at all. but they will be! .)
     * At the very moment, this method checks only if the "live" content is not more recent than the cached one.
     * 
     * @return  bool  true if the validityObject indicates that the cached version can be used, false otherwise.
     * @param   object  validityObject
     */
    function checkValidityDefault($validityObject){
        return(isset($validityObject['src'])       &&
               isset($validityObject['filemtime']) &&
               file_exists($validityObject['src']) &&
               ($validityObject['filemtime'] >= filemtime($validityObject['src'])));         //! no good ! they're always euqal..
    }


}



?>
