<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: generator.php,v 1.4 2003/07/09 19:32:48 glandium Exp $

include_once(PAPAAN_BASE.'/components/component.php');

/**
* Class for generating xml document
*
* generators are used to generate the initial XML in <map:generate>
* Not much here at the moment. maybe in the future...
*  I'm not sure, if we really need this 
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: generator.php,v 1.4 2003/07/09 19:32:48 glandium Exp $
* @package  papaan
*/
class generator extends component {

	var $entities;

	/**
    * Constructor
    *
    *
	*/
	function generator(&$sitemap,$config) {
		$this->component(&$sitemap,$config);
	}

	/**
    * Initiator, called after construction of object
    *
    *  This method will be called in the start element with the attributes from this element
    *
    *  @param $attribs array	associative array with element attributes
    *  @access public
	*/
    function init($attribs)
    {
    	parent::init($attribs);
	}
    
    /**
    * Does the generation of the xml Document
    *
    * The XML-Document is passed by reference, to save copying of large XML-DOcuments
    *  The generated XML-Document can be a DomDocument-Object or a XML-String, but preferred
    *  is DomDocument.
    *
    * @access public
    * @param mixed XML-Document 
    * @returns bool
    */
    function DomStart(&$xml)
    {
    }
	
	
	/**
	*
	* Encodes Entities in XML-string
	*
	*/
	
	function setEntities($ent=NULL) {
		if(is_array($ent)) {
			$this->entities = $ent;
		} else {
		
			$this->entities = array (	'&OElig;' => '&#338;',
                   						'&oelig;' => '&#339;',
                           				'&Scaron;' => '&#352;',
                           				'&scaron;' => '&#353;',
                           				'&Yuml;' => '&#376;',
                           				'&circ;' => '&#710;',
                           				'&tilde;' => '&#732;',
                           				'&ensp;' => '&#8194;',
                           				'&emsp;' => '&#8195;',
                           				'&thinsp;' => '&#8201;',
                           				'&zwnj;' => '&#8204;',
                           				'&zwj;' => '&#8205;',
                           				'&lrm;' => '&#8206;',
                           				'&rlm;' => '&#8207;',
                           				'&ndash;' => '&#8211;',
                           				'&mdash;' => '&#8212;',
                           				'&lsquo;' => '&#8216;',
                           				'&rsquo;' => '&#8217;',
                           				'&sbquo;' => '&#8218;',
                           				'&ldquo;' => '&#8220;',
                           				'&rdquo;' => '&#8221;',
                           				'&bdquo;' => '&#8222;',
                           				'&dagger;' => '&#8224;',
                           				'&Dagger;' => '&#8225;',
                           				'&permil;' => '&#8240;',
                           				'&lsaquo;' => '&#8249;',
                           				'&rsaquo;' => '&#8250;',
                           				'&euro;' => '&#8364;',
                           				'&bull;' => '&#8226;',
                           				'& ' =>'&amp;',
                           				'<' => '&#60;',
										'&lt;' => '&#60;',
										'>' => '&#62;',
										'&gt;' => '&#62;'
										);
		}
	} 
	
	
	function entity_decode($val) {
		if($this->entities == NULL || !is_array($this->entities)) {
			$this->setEntities();
		}
		return strtr($val,$this->entities);
    }
	
	
	
	
}
