<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsp="http://apache.org/xsp" xmlns:esql="http://apache.org/cocoon/SQL/v2">
<xsl:param name="namespace-uri">http://apache.org/cocoon/SQL/v2</xsl:param>
<xsl:include href="logicsheet-util.xsl"/>

<xsl:template match="xsp:page">
<xsp:page>
<xsp:structure>
<xsp:include>DB.php</xsp:include>
</xsp:structure>
<xsl:apply-templates/>
</xsp:page>
</xsl:template>

<xsl:template match="esql:connection">
<xsp:logic>
<xsl:text>$db = DB::connect(</xsl:text>
<xsl:choose>
<xsl:when test="esql:pool">
$this->sitemap->db_pools[<xsl:call-template name="get-string"><xsl:with-param name="node" select="esql:pool"/></xsl:call-template>]
</xsl:when>
<xsl:otherwise>
<xsl:call-template name="get-string"><xsl:with-param name="node" select="esql:driver"/></xsl:call-template>.'://'.<xsl:call-template name="get-string"><xsl:with-param name="node" select="esql:username"/></xsl:call-template>.':'.<xsl:call-template name="get-string"><xsl:with-param name="node" select="esql:password"/></xsl:call-template>.'@'.<xsl:call-template name="get-string"><xsl:with-param name="node" select="esql:dburl"/></xsl:call-template>
</xsl:otherwise>
</xsl:choose>
<xsl:text>);
</xsl:text>
<xsl:apply-templates/>
</xsp:logic>
</xsl:template>

<xsl:template match="esql:connection//esql:dburl|esql:connection//esql:driver|esql:connection//esql:username|esql:connection//esql:password|esql:connection//esql:pool"/>

<xsl:template match="esql:connection/esql:execute-query">
<xsp:logic>
<xsl:choose>
<xsl:when test="esql:max-rows">
$db_result = $db->limitquery(<xsl:call-template name="get-string"><xsl:with-param name="node" select="esql:query"/></xsl:call-template>,<xsl:choose>
<xsl:when test="esql:skip-rows">
<xsl:call-template name="get-string"><xsl:with-param name="node" select="esql:skip-rows"/></xsl:call-template>
</xsl:when>
<xsl:otherwise>
0
</xsl:otherwise>
</xsl:choose>,<xsl:call-template name="get-string"><xsl:with-param name="node" select="esql:max-rows"/></xsl:call-template>);
</xsl:when>
<xsl:otherwise>
$db_result = $db->query(<xsl:call-template name="get-string"><xsl:with-param name="node" select="esql:query"/></xsl:call-template>);
</xsl:otherwise>
</xsl:choose>

if (DB::isError($db_result)) {
<xsl:apply-templates select="esql:error-results"/>
} else if ($db_result->numRows()) {
<xsl:apply-templates select="esql:results"/>
} else if ($db_result->affectedRows()) {
<xsl:apply-templates select="esql:update-results"/>
} else {
<xsl:apply-templates select="esql:no-results"/>
}
</xsp:logic>
</xsl:template>

<xsl:template match="esql:execute-query/esql:results|esql:execute-query//esql:error-results|esql:execute-query//esql:update-results|esql:execute-query//esql:no-results">
<xsp:content>
<xsl:apply-templates/>
</xsp:content>
</xsl:template>

<xsl:template match="esql:results//esql:row-results">
<xsp:logic>
$db_row_count = 1;
while ($db_row = $db_result->fetchRow(DB_FETCHMODE_ASSOC)) {
<xsp:content>
<xsl:apply-templates/>
</xsp:content>
$db_row_count++;
}
</xsp:logic>
</xsl:template>

<xsl:template match="esql:row-results//esql:get-columns">
<xsp:logic>
foreach($db_row as $key => $value) {
<xsp:element>
<xsp:param name="name"><xsp:expr>$key</xsp:expr></xsp:param>
<xsp:expr>$value</xsp:expr>
</xsp:element>
}
</xsp:logic>
</xsl:template>

<xsl:template match="esql:row-results//esql:get-string|esql:row-results//esql:get-date|esql:row-results//esql:get-time|esql:row-results//esql:get-timestamp|esql:row-results//esql:get-double|esql:row-results//esql:get-float|esql:row-results//esql:get-int|esql:row-results//esql:get-long|esql:row-results//esql:get-short">
<xsp:expr>$db_row[<xsl:call-template name="get-string"><xsl:with-param name="node" select="@column"/></xsl:call-template>]</xsp:expr>
</xsl:template>

<xsl:template match="esql:row-results//esql:get-boolean">
<xsp:expr>($db_row[<xsl:call-template name="get-string"><xsl:with-param name="node" select="@column"/></xsl:call-template>]?true:false)</xsp:expr>
</xsl:template>

<xsl:template match="esql:row-results//esql:get-row-position">
<xsp:expr>$db_row_count</xsp:expr>
</xsl:template>

<xsl:template match="esql:row-results//esql:get-xml">
<xsp:logic>
<xsl:text>$node->add_child(xmldoc($db_row[</xsl:text>
<xsl:if test="@root">
<xsl:text>'&lt;</xsl:text><xsl:value-of select="@root"/><xsl:text>&gt;'.</xsl:text>
</xsl:if>
<xsl:call-template name="get-string"><xsl:with-param name="node" select="@column"/></xsl:call-template>
<xsl:if test="@root">
<xsl:text>'&lt;/</xsl:text><xsl:value-of select="@root"/><xsl:text>&gt;'.</xsl:text>
</xsl:if>
<xsl:text>]));</xsl:text>
</xsp:logic>
</xsl:template>

</xsl:stylesheet>
