<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Mike Hommey <mh@glandium.org>                                |
// +----------------------------------------------------------------------+
//
// $Id: wildcard_header.php,v 1.6 2003/07/12 09:22:43 glandium Exp $

include_once(PAPAAN_BASE.'/components/matcher.php');

/**
* Matches an  uri 
*
* @author   Mike Hommey <mh@glandium.org>
* @version  $Id: wildcard_header.php,v 1.6 2003/07/12 09:22:43 glandium Exp $
* @package  papaan
*/
class matcher_wildcard_header extends matcher_wildcard
{

    function matcher_wildcard_header (&$sitemap, $config) {

		parent::matcher_wildcard($sitemap, $config);
		// Quick and dirty way ; should check more cleanly if there's no garbage in configuration
		$xpath = xpath_new_context($this->config['dom']);
		$xnode = xpath_eval($xpath,'/config/header-name');
		if (count($xnode->nodeset) != 1) {
			papaan::raiseError('Exactly one header-name definition expected in configuration',PAPAAN_ERROR_FATAL);
		}
		$header_name = $xnode->nodeset[0]->get_content();
	        if ($header_name) {
			$tmp = 'HTTP_'.strtoupper(strtr($header_name,'-','_'));
			if (isset($_SERVER[$tmp])) {
				$this->header = $_SERVER[$tmp];
			} else {
				$this->header = '';
/* Should check if header belongs to a list of valid HTTP headers
				papaan::raiseError('No such header: '.$header_name,PAPAAN_ERROR_FATAL); */
			}
		} else {
			papaan::raiseError('No header name specified to wildcard header matcher',PAPAAN_ERROR_FATAL);
		}
    }

	function match($value)
    {
		return parent::match($value, $this->header);
	}
}
