<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Mike Hommey <mh@glandium.org>                                |
// +----------------------------------------------------------------------+
//
// $Id: request_parameter.php,v 1.5 2003/07/26 23:01:49 glandium Exp $

include_once(PAPAAN_BASE.'/components/selector.php');

/**
* @author   Mike Hommey <mh@glandium.org>
* @version  $Id: request_parameter.php,v 1.5 2003/07/26 23:01:49 glandium Exp $
* @package  papaan
*/
class selector_request_parameter extends selector
{

    function selector_request_parameter (&$sitemap, $config) {

		parent::selector($sitemap, $config);
		$xpath = xpath_new_context($this->config['dom']);
		$xnode = xpath_eval($xpath,'/config/parameter-name');
		if (count($xnode->nodeset) != 1) {
			papaan::raiseError('Exactly one parameter-name definition expected in configuration',PAPAAN_ERROR_FATAL);
		}
		$this->parameter_name = $xnode->nodeset[0]->get_content();
    }

	function test($value)
    {
		if ($param = $this->sitemap->request->get_parameter($this->parameter_name)) {
			return ($value == $param);
		} 
		return FALSE;
	}
}
