<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsp="http://apache.org/xsp">
<xsl:include href="../common.xsl"/>

<xsl:template match="@*|node()[namespace-uri() != $namespace-uri]" priority="-1">
<xsl:copy><xsl:apply-templates select="@*|node()"/></xsl:copy>
</xsl:template>

<xsl:template name="get-param">
<xsl:param name="name"/>
<xsl:choose>
<xsl:when test="@*[name() = $name]">
<xsl:value-of select="@*[name() = $name]"/>
</xsl:when>
<xsl:when test="*[local-name() = 'param' and @name = $name and namespace-uri() = $namespace-uri]">
<xsl:apply-templates select="*[local-name() = 'param' and @name = $name and namespace-uri() = $namespace-uri]"/>
</xsl:when>
</xsl:choose>
</xsl:template>

<xsl:template name="get-string-param">
<xsl:param name="name"/>
<xsl:choose>
<xsl:when test="@*[name() = $name]">'<xsl:call-template name="escapeSingleQuotes"><xsl:with-param name="text" select="@*[name() = $name]"/></xsl:call-template>'</xsl:when>
<xsl:when test="*[local-name() = 'param' and @name = $name and namespace-uri() = $namespace-uri]">
<xsl:call-template name="get-string"><xsl:with-param name="node" select="*[local-name() = 'param' and @name = $name and namespace-uri() = $namespace-uri]"/></xsl:call-template>
</xsl:when>
</xsl:choose>
</xsl:template>

<xsl:template name="get-string">
<xsl:param name="node"/>
<xsl:if test="not($node/*|$node/text())">
<xsl:text>'</xsl:text>
<xsl:call-template name="escapeSingleQuotes"><xsl:with-param name="text" select="$node"/></xsl:call-template>
<xsl:text>'</xsl:text>
</xsl:if>
<xsl:for-each select="$node/*|$node/text()">
<xsl:if test="position()!=1">
<xsl:text>.</xsl:text>
</xsl:if>
<xsl:choose>
<xsl:when test="$node/*">
<xsl:apply-templates select="$node/*"/>
</xsl:when>
<xsl:otherwise>'<xsl:call-template name="escapeSingleQuotes"><xsl:with-param name="text" select="$node"/></xsl:call-template>'</xsl:otherwise>
</xsl:choose>
</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
