<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsp="http://apache.org/xsp" xmlns:xsp-request="http://apache.org/xsp/request/2.0">
<xsl:param name="namespace-uri">http://apache.org/xsp/request/2.0</xsl:param>
<xsl:include href="logicsheet-util.xsl"/>

<xsl:template match="xsp-request:get-attribute">
<xsp:expr>$this->sitemap->request->get_attribute(<xsl:call-template name="get-string-param"><xsl:with-param name="name">name</xsl:with-param></xsl:call-template>)</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:get-header">
<xsp:expr>$this->sitemap->request->get_header(<xsl:call-template name="get-string-param"><xsl:with-param name="name">name</xsl:with-param></xsl:call-template>)</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:get-method">
<xsp:expr>$this->sitemap->request->get_server_var('REQUEST_METHOD')</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:get-parameter">
<xsp:expr>$this->sitemap->request->get_parameter(<xsl:call-template name="get-string-param"><xsl:with-param name="name">name</xsl:with-param></xsl:call-template>)</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:get-path-info">
<xsp:expr>$this->sitemap->request->path_info</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:get-uri">
<xsp:expr>$this->sitemap->request->request_uri</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:get-remote-address">
<xsp:expr>$this->sitemap->request->get_server_var('REMOTE_ADDR')</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:get-sitemap-uri">
<xsp:expr>$this->sitemap->uri</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:get-server-name">
<xsp:expr>$this->sitemap->request->get_server_var('SERVER_NAME')</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:get-server-port">
<xsp:expr>$this->sitemap->request->get_server_var('SERVER_PORT')</xsp:expr>
</xsl:template>

<xsl:template match="xsp-request:remove-attribute">
<xsp:logic>$this->sitemap->request->remove_attribute(<xsl:call-template name="get-string-param"><xsl:with-param name="name">name</xsl:with-param></xsl:call-template>);</xsp:logic>
</xsl:template>

<xsl:template match="xsp-request:set-attribute">
<xsp:logic>$this->sitemap->request->set_attribute(<xsl:call-template name="get-string-param"><xsl:with-param name="name">name</xsl:with-param></xsl:call-template>,<xsl:call-template name="get-string"><xsl:with-param name="node" select="."/></xsl:call-template>);</xsp:logic>
</xsl:template>

</xsl:stylesheet>
