<?php
// +----------------------------------------------------------------------+
// | papaan                                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001,2002,2003 Bitflux GmbH                            |
// +----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or        |
// | modify it under the terms of the GNU General Public License (GPL)    |
// | as published by the Free Software Foundation; either version 2       |
// | of the License, or (at your option) any later version.               |
// | The GPL can be found at http://www.gnu.org/licenses/gpl.html         |
// +----------------------------------------------------------------------+
// | Author: Christian Stocker <chregu@bitflux.ch>                        |
// +----------------------------------------------------------------------+
//
// $Id: serializer.php,v 1.5 2003/07/22 17:59:50 glandium Exp $

include_once(PAPAAN_BASE.'/components/component.php');

/**
* Base class for serializers
*
*	Serializers are used for outputting the actual data with <map:serializer>
*
* @author   Christian Stocker <chregu@bitflux.ch>
* @version  $Id: serializer.php,v 1.5 2003/07/22 17:59:50 glandium Exp $
* @package  papaan
*/

class serializer extends component {

	function serializer(&$sitemap, $config) {
		$this->component($sitemap, $config);
	}

    function init($attribs) {
        parent::init($attribs);
    }

	function DomStart(&$xml) {
	if (! $xml) {
	      $this->sitemap->raiseError($this,'fatal','No input to serializer.');
	  }
	}
    
    function SaxDefaultHandler(&$context,&$data)
    {
    }

    function SaxStartElement(&$context,&$element,&$attribs)
    {
    }
        
    function SaxEndElement(&$context,&$element)
    {
    }

    function SaxCharacterData(&$context,&$element)
    {
    }


    /* CACHING */

    /**
     * Generate valdityObject
     *
     * ValidityObjects for serializer are made up from the last cacheKey and the 
     * modification time of the serializer itself and it's other attributes.
     * Like it is done now, all serializers are cachable by default, they implement the
     * 'cachable' interface.
     *
     * @return  array  validityObject
     * @param   array  $attribs component attributes
     * @param   string $keyBefore
     * @author Hannes Gassert <hannes.gassert@unifr.ch>
     */
    function generateValidity(){
        $validityObject = $this->attribs;
        
        /*
        $validityObject['filemtime'] = filemtime(PAPAAN_BASE . '/components/serializers/'. $validityObject['type'].'.php'); //jesses! a hardcoded path! .)
        */
        return($validityObject);
    }

    /**
     * Check validity :)
     *
     * Returns true now, in any case. If there will be serializers who aren't always cachable, they mus provide
     * a checkValidity/generateValdity pair of their own.
     *
     * @param  array  $validityObject needs to have a key 'filemtime'
     */
    function checkValidity($validityObject){
        /*
        return(isset($validityObject['filemtime']) &&
               ($validityObject['filemtime'] >= filemtime(PAPAAN_BASE . '/components/serializers/'. $validityObject['type'].'.php')));
        */
        return(true);
    }

    /**
     * Generates cacheKey
     *
     * just an alias for generateKeyDefault
     *
     * @return  string  $cacheKey
     */
    function generateKey($attribs, $keyBefore){
        return($this->generateKeyDefault($attribs, $keyBefore));
    }

    
}
